//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: evmos/erc20/v1/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the erc20 Msg service.
///
/// Usage: instantiate `Evmos_Erc20_V1_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Evmos_Erc20_V1_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Evmos_Erc20_V1_MsgClientInterceptorFactoryProtocol? { get }

  func convertCoin(
    _ request: Evmos_Erc20_V1_MsgConvertCoin,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Erc20_V1_MsgConvertCoin, Evmos_Erc20_V1_MsgConvertCoinResponse>

  func convertERC20(
    _ request: Evmos_Erc20_V1_MsgConvertERC20,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Erc20_V1_MsgConvertERC20, Evmos_Erc20_V1_MsgConvertERC20Response>
}

extension Evmos_Erc20_V1_MsgClientProtocol {
  internal var serviceName: String {
    return "evmos.erc20.v1.Msg"
  }

  /// ConvertCoin mints a ERC20 representation of the SDK Coin denom that is
  /// registered on the token mapping.
  ///
  /// - Parameters:
  ///   - request: Request to send to ConvertCoin.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func convertCoin(
    _ request: Evmos_Erc20_V1_MsgConvertCoin,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Erc20_V1_MsgConvertCoin, Evmos_Erc20_V1_MsgConvertCoinResponse> {
    return self.makeUnaryCall(
      path: "/evmos.erc20.v1.Msg/ConvertCoin",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeConvertCoinInterceptors() ?? []
    )
  }

  /// ConvertERC20 mints a Cosmos coin representation of the ERC20 token contract
  /// that is registered on the token mapping.
  ///
  /// - Parameters:
  ///   - request: Request to send to ConvertERC20.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func convertERC20(
    _ request: Evmos_Erc20_V1_MsgConvertERC20,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Erc20_V1_MsgConvertERC20, Evmos_Erc20_V1_MsgConvertERC20Response> {
    return self.makeUnaryCall(
      path: "/evmos.erc20.v1.Msg/ConvertERC20",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeConvertERC20Interceptors() ?? []
    )
  }
}

internal protocol Evmos_Erc20_V1_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'convertCoin'.
  func makeConvertCoinInterceptors() -> [ClientInterceptor<Evmos_Erc20_V1_MsgConvertCoin, Evmos_Erc20_V1_MsgConvertCoinResponse>]

  /// - Returns: Interceptors to use when invoking 'convertERC20'.
  func makeConvertERC20Interceptors() -> [ClientInterceptor<Evmos_Erc20_V1_MsgConvertERC20, Evmos_Erc20_V1_MsgConvertERC20Response>]
}

internal final class Evmos_Erc20_V1_MsgClient: Evmos_Erc20_V1_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Evmos_Erc20_V1_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the evmos.erc20.v1.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Evmos_Erc20_V1_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the erc20 Msg service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Evmos_Erc20_V1_MsgProvider: CallHandlerProvider {
  var interceptors: Evmos_Erc20_V1_MsgServerInterceptorFactoryProtocol? { get }

  /// ConvertCoin mints a ERC20 representation of the SDK Coin denom that is
  /// registered on the token mapping.
  func convertCoin(request: Evmos_Erc20_V1_MsgConvertCoin, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Erc20_V1_MsgConvertCoinResponse>

  /// ConvertERC20 mints a Cosmos coin representation of the ERC20 token contract
  /// that is registered on the token mapping.
  func convertERC20(request: Evmos_Erc20_V1_MsgConvertERC20, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Erc20_V1_MsgConvertERC20Response>
}

extension Evmos_Erc20_V1_MsgProvider {
  internal var serviceName: Substring { return "evmos.erc20.v1.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "ConvertCoin":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Erc20_V1_MsgConvertCoin>(),
        responseSerializer: ProtobufSerializer<Evmos_Erc20_V1_MsgConvertCoinResponse>(),
        interceptors: self.interceptors?.makeConvertCoinInterceptors() ?? [],
        userFunction: self.convertCoin(request:context:)
      )

    case "ConvertERC20":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Erc20_V1_MsgConvertERC20>(),
        responseSerializer: ProtobufSerializer<Evmos_Erc20_V1_MsgConvertERC20Response>(),
        interceptors: self.interceptors?.makeConvertERC20Interceptors() ?? [],
        userFunction: self.convertERC20(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Evmos_Erc20_V1_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'convertCoin'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeConvertCoinInterceptors() -> [ServerInterceptor<Evmos_Erc20_V1_MsgConvertCoin, Evmos_Erc20_V1_MsgConvertCoinResponse>]

  /// - Returns: Interceptors to use when handling 'convertERC20'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeConvertERC20Interceptors() -> [ServerInterceptor<Evmos_Erc20_V1_MsgConvertERC20, Evmos_Erc20_V1_MsgConvertERC20Response>]
}
